#! /bin/bash
# $Id: vserver-build,v 1.7 2004/02/04 02:46:43 ensc Exp $

# Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
#  
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#  
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

: ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
test -e "$UTIL_VSERVER_VARS" || {
    echo "Can not find util-vserver installation; aborting..."
    exit 1
}
. "$UTIL_VSERVER_VARS"
. "$_LIB_FUNCTIONS"
. "$_LIB_VSERVER_SETUP_FUNCTIONS"
. "$_LIB_VSERVER_BUILD_FUNCTIONS"

### Some local functions

function showHelp()
{
    echo \
$"Usage: $(basename $0) -m <method> -n <name> --force <cfg-options>*
    --rootdir <dir> --pkgcfgbase <dir> [--] <method-args>*

Options:
    --force     ...  remove/rename already existing vservers with the same name
    -m <method> ...  use method <method>; see below for possible values
    --rootdir <dir>
                ...  [default: $DEFAULT_VSERVERDIR]
    --pkgcfgbase <dir>
                ...  [default: $DEFAULT_VSERVERPKGDIR]
      
cfg-options are: $SETUP_HELPMSG

Possible methods are:
    legacy      ...  the \"old\" copy-all-from-host method, which requires the
                     old legacy  vserver-legacy script;  with  this method the
		     cfg-options will be ignored
    copy        ...  the copy-all-from-host method which uses the recent
                     configuration scheme
    apt-rpm ... -- -d <distribution>
                ...  installs the base-packages of the given distribution with
		     help of 'vapt-get'
    skeleton ... -- [<cmd> <args>*]
                ...  installs a minimal skeleton filesystem, creates the
		     configuration file and calls an optional command then
    debootstrap ... -- -d <distribution> [-m <mirror>]
                     bootstraps the vserver with Debian's 'debootstrap' package

Please report bugs to $PACKAGE_BUGREPORT"
    exit 0
}

function showVersion()
{
    echo \
$"vserver-build $PACKAGE_VERSION -- initializes a vserver
This program is part of $PACKAGE_STRING

Copyright (C) 2003 Enrico Scholz
This program is free software; you may redistribute it under the terms of
the GNU General Public License.  This program has absolutely no warranty."
    exit 0
}

### main starts here

set -e

declare -a default_opts=()
test "$NO_DEFAULT_OPTS" || getFileArray default_opts "$CONFDIR/.defaults/apps/build/options"

tmp=$(getopt -o +m:n: --long force,debug,help,version,rootdir:,pkgbase:,$SETUP_OPTIONS -n "$(basename $0)" -- \
	"${default_opts[@]}" "$@") || exit 1
eval set -- "$tmp"

VSERVER_NAME=
OPTION_FORCE=

while true; do
    case "$1" in
	--help)    showHelp $0 ;;
	--version) showVersion ;;
	--force)   OPTION_FORCE=1;;
	--debug)   set -x;;
	--rootdir) ROOTDIR=$2;      shift;;
	--pkgbase) PKGCFGBASE=$2;   shift;;
	-m)	   method=$2;       shift;;
	-n)	   VSERVER_NAME=$2; shift;;
	--)	   shift; break;;
	*)
	    { setup_setOption2 "$1" "$2" && shift; } || \
	    { echo $"vserver-build: internal error."; exit 1; }
	    ;;
    esac
    shift
done

test "$VSERVER_NAME" || {
    echo $"Name of vserver not specified"
    exit 1
}

setup_setDefaults "$VSERVER_NAME"

case x"$method" in
    xlegacy)	exec $_VSERVER_LEGACY "$VSERVER_NAME" build "$@" ;;
    xapt-rpm|xcopy|xskeleton|xdebootstrap)
		. $PKGLIBDIR/vserver-build.$method
		;;
    x)		echo $"No build-method specified" >&2
		exit 1
		;;
    *)		echo $"Unknown build-method '$method'" >&2
		exit 1
		;;
esac
